'From Objectworks for Smalltalk-80(tm), Version 2.5 of 29 July 1989 on 22 March 1995 at 9:00:06 pm'!

HistoryCrum subclass: #HBottomCrum
	instanceVariableNames: '
		myTrace {TracePosition}
		myBertCrum {BertCrum}
		myEditions {MuSet of: BeEditions}'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xanadu-Be-Ents'!

(HBottomCrum getOrMakeCxxClassDescription)
	attributes: ((Set new) add: #CONCRETE; add: #COPY; yourself)!

!HBottomCrum methodsFor: 'testing'!

{BooleanVar} hasRefs
	"Return true if there are stamps that
	 point at this orgl."

	^myEditions isEmpty not!

{Boolean} inTrace: trace {TracePosition}
	"Return true if the receiver can backfollow to trace."

	Dean hack.  "The following grotesque hack (myEdition isEmpty not) is so that intermediate orglRoots generated by copy and combine are not considered for version comparison.  The proper thing to do is make those operations destroy their intermediate results."
	^(myTrace basicCast: Heaper star) == trace and: [myEditions isEmpty not]!

{BooleanVar} isEmpty
	"Return true if their are no upward pointers.  This is used
	 by OParts to determine if they can be forgotten."
	
	^myEditions isEmpty!

{Boolean} propagateBCrum: newBCrum {BertCrum} 
	"If bertCrum is leafward of newBCrum then change it and return true, 
	otherwise return false."

	(myBertCrum isLE: newBCrum)
		ifTrue: [^false]
		ifFalse: 
			[myBertCrum _ newBCrum.
			^true]! !

!HBottomCrum methodsFor: 'accessing'!

{TracePosition} hCut
	^myTrace!

{Mapping} mappingTo: trace {TracePosition} with: initial {Mapping}
	"return the mapping into the domain space of the given trace"
	(self inTrace: trace)
		ifTrue: [^initial]
		ifFalse: [^Mapping make: initial coordinateSpace with: initial rangeSpace]!

{ImmuSet of: OPart} oParents
	^ImmuSet make! !

!HBottomCrum methodsFor: 'filtering'!

{void} actualDelayedStoreBackfollow: finder {PropFinder} 
	with: fossil {RecorderFossil}
	with: recorder {ResultRecorder}
	with: hCrumCache {HashSetCache of: HistoryCrum}

	(myEditions isEmpty not and: [finder doesPass: myBertCrum]) ifTrue:
		[myEditions stepper forEach: [:edition {BeEdition} | 
			recorder delayedStoreBackfollow: edition
				with: finder
				with: fossil
				with: hCrumCache]]!

{BooleanVar} anyPasses: finder {PropFinder}
	(finder doesPass: myBertCrum) ifTrue:
		[myEditions stepper forEach: [:edition {BeEdition} |
			(edition anyPasses: finder)
				ifTrue: [^true]]].
	^false!

{BertCrum} bertCrum
	^myBertCrum!

{void} introduceEdition: edition {BeEdition}

	myEditions introduce: edition.
	(self propChanger: PropChange bertPropChange) schedule!

{AgendaItem} propChanger: change {PropChange}
	"NOTE: The AgendaItem returned is not yet scheduled.  Doing so is up to my caller."

	| newProp {Prop} |
	newProp _ BertProp make.
	myEditions stepper forEach: [:edition {BeEdition} |
		newProp _ change with: newProp with: edition prop].
	^myBertCrum propChanger: change with: newProp!

{void} removeEdition: edition {BeEdition}

	myEditions remove: edition.
	(self propChanger: PropChange bertPropChange) schedule!

{void} ringDetectors: edition {FeEdition}

	self bertCrum isSensorWaiting ifTrue:
		[myEditions stepper forEach: [ :ed {BeEdition} |
			ed ringDetectors: edition]]! !

!HBottomCrum methodsFor: 'create'!

create: trace {TracePosition} with: canopy {BertCrum}
	super create.
	myTrace _ trace.
	myBertCrum _ canopy.
	myBertCrum addPointer: self.
	myEditions _ MuSet make! !

!HBottomCrum methodsFor: 'smalltalk:'!

inspectOrgls
	(myStamps == NULL or: [myStamps isEmpty]) ifTrue:
		[^Transcript show: 'Nobody'; cr; endEntry].
	myStamps count == 1
		ifTrue: [myStamps stepper fetch orglRoot inspect]
		ifFalse: [(myStamps asOrderedCollection collect: [ :stamp | stamp orglRoot]) inspect]!

printOn: aStream
	super printOn: aStream.
	(myEditions ~~ NULL and: [myEditions isEmpty not]) ifTrue: [aStream nextPut: $*].! !

!HBottomCrum methodsFor: 'smalltalk: gc'!

{void} markChildren: count {IntegerVar}
	myTrace markInstances: count.
	myBertCrum markInstances: count.! !

!HBottomCrum methodsFor: 'smalltalk: passe'!

{void} introduceStamp: stamp {BeEdition}

	self passe!

{void} propChanged: change {PropChange}

	self passe!

{void} removeStamp: stamp {BeEdition}

	self passe! !

!HBottomCrum methodsFor: 'deferred accessing'!

{XnRegion} fetchRegionIn: stamp {BeEdition} with: hCut {TracePosition} with: region {XnRegion}

	Dean shouldImplement. "or else remove it again and get rid of polymorphs"
	^NULL "fodder"! !

!HBottomCrum methodsFor: 'generated:'!

create.Rcvr: receiver {Rcvr}
	super create.Rcvr: receiver.
	myTrace _ receiver receiveHeaper.
	myBertCrum _ receiver receiveHeaper.
	myEditions _ receiver receiveHeaper.!

{void} sendSelfTo: xmtr {Xmtr}
	super sendSelfTo: xmtr.
	xmtr sendHeaper: myTrace.
	xmtr sendHeaper: myBertCrum.
	xmtr sendHeaper: myEditions.! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

HBottomCrum class
	instanceVariableNames: ''!

(HBottomCrum getOrMakeCxxClassDescription)
	attributes: ((Set new) add: #CONCRETE; add: #COPY; yourself)!

!HBottomCrum class methodsFor: 'instance creation'!

{HBottomCrum} make
	[Ent] USES.
	^self create: CurrentTrace fluidGet with: CurrentBertCrum fluidGet! !