'From Objectworks for Smalltalk-80(tm), Version 2.5 of 29 July 1989 on 22 March 1995 at 8:59:34 pm'!

Heaper subclass: #TransclusionRecorder
	instanceVariableNames: '
		myKeyMaster {FeKeyMaster}
		myEndorsementsFilter {Filter of: ID}
		myTrail {FeEdition}
		myRecordedEditions {HashSetCache of: BeEdition}'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xanadu-backrec'!

(TransclusionRecorder getOrMakeCxxClassDescription)
	attributes: ((Set new) add: #CONCRETE; yourself)!

!TransclusionRecorder methodsFor: 'accessing'!

{PropFinder} bertPropFinder
	
	^PropFinder 
		backfollowFinder: myKeyMaster permissionsFilter 
		with: myEndorsementsFilter!

{Filter} endorsementsFilter  
	^myEndorsementsFilter!

{Filter of: ID} permissionsFilter

	self thingToDo. "cache or something"
	[BeGrandMap] USES.
	^CurrentGrandMap fluidGet globalIDFilterSpace anyFilter: myKeyMaster actualAuthority!

{SensorProp} sensorProp
	
	^SensorProp make: myKeyMaster permissionsFilter with: myEndorsementsFilter with: false! !

!TransclusionRecorder methodsFor: 'create'!

create: eFilter {Filter of: Tuple}
	with: trail {FeEdition}
	with: recorded {HashSetCache of: BeEdition}

	super create.
	myKeyMaster _ CurrentKeyMaster fluidGet.
	myEndorsementsFilter _ eFilter.
	myTrail _ trail.
	myRecordedEditions := recorded.! !

!TransclusionRecorder methodsFor: 'recording'!

{void} record: answer {FeEdition}
	"record the answer into myTrail.

	Should usually suppresses redundant records of the same stamp.  (These are typically generated by a race between the now and future parts of a backfollow, which are guaranteed to err by overlapping rather than gapping.  They may also be generated by a crash/reboot during AgendaItem processing.)"
	
	MarkM hack.
	
	(myRecordedEditions hasMember: answer beEdition) ifFalse:
		[myRecordedEditions store: answer beEdition.
		(myTrail get: (myTrail coordinateSpace cast: IDSpace) newID) makeIdentical: answer]!

{void} triggerIfMatchingEdition: allegedAnswer {BeEdition} 
	with: finder {PropFinder} 
	with: fossil {TransclusionFossil}
	"check whether this stamp is newly visible to this recorder and record it if so"
	
	"This test is to ensure that the semantics of delayed backfollow match that of
	the immediate backfollow -- i.e. the current stamp matches the endorsements filter,
	and there exists a stamp containing this one which passes the permissions filter"

	finder 
		cast: AbstractRecorderFinder into: [:arf |
			arf checkStamp: allegedAnswer with: self with: fossil]
		others: []! !

!TransclusionRecorder methodsFor: 'obsolete:'!

{SensorProp} prop
	
	^self sensorProp! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

TransclusionRecorder class
	instanceVariableNames: ''!

(TransclusionRecorder getOrMakeCxxClassDescription)
	attributes: ((Set new) add: #CONCRETE; yourself)!

!TransclusionRecorder class methodsFor: 'pseudo constructors'!

make: eFilter {Filter of: Tuple}
	with: trail {FeEdition}
	with: recorded {HashSetCache of: BeEdition}

	^self create: eFilter with: trail with: recorded! !