'From Objectworks for Smalltalk-80(tm), Version 2.5 of 29 July 1989 on 22 March 1995 at 9:03:16 pm'!

XuPromise subclass: #XuArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'X++ PrimArrays'!
XuArray comment:
'Array objects in smalltalk vary in size, while in x++ they allocate separate storage for the varying part.  Thus they require very different Recipes.

Recipes are normally registered by the class'' associated Recipe class at its own initialization time.  In smalltalk, the Array classes share a common Recipe class, (STArrayRecipe), which registers an instance of itself for each appropriate concrete subclass of PrimArray.X.

UInt1Arrays are odd in smalltalk, and get normal recipes generated by the normal smalltalk stubble mechanism

(WeakPtrArrays are not in the browser because they currently have no clients and may disappear.)'!

(XuArray getOrMakeCxxClassDescription)
	attributes: ((Set new) add: #CONCRETE; yourself)!

!XuArray methodsFor: 'smalltalk: defaults'!

{XuVoid} at: to {XuIntValue} storeMany: source {XuArray} 

	^self  at: to storeMany: source with: DefaultMinusOne with: DefaultZero!

{XuVoid} at: to {XuIntValue} storeMany: source {XuArray} with: count {XuIntValue default: DefaultMinusOne} 

	^self  at: to storeMany: source with: count with: DefaultZero!

{XuArray} copy

	^self  copy: DefaultMinusOne with: DefaultZero!

{XuArray} copy: count {XuIntValue default: DefaultMinusOne} 

	^self  copy: count with: DefaultZero!

{XuArray} copy: count {XuIntValue default: DefaultMinusOne} with: start {XuIntValue default: DefaultZero} 

	"This method has no comment."
	
	| retVal {XuArray} |
	(self isBroken) ifTrue:
		[^XuArray makeBrokenBy: self].
	(count isBroken) ifTrue:
		[^XuArray makeBrokenBy: count].
	(start isBroken) ifTrue:
		[^XuArray makeBrokenBy: start].

	Heaper problems.AllBlasts 
		handle: [:ex | retVal _ XuArray makeBroken: ex asProblem. ex return]
		do: 	[retVal _ XuArray make: (self getActualPrimArray copy:count getActualInt32 with:start getActualInt32)].
	XuPromise inDelayBlock ifFalse:
		[XuPromise force.
		retVal isBroken ifTrue: [retVal explode]].
	^retVal!

{XuArray} copy: count {XuIntValue default: DefaultMinusOne} with: start {XuIntValue default: DefaultZero} with: before {XuIntValue default: DefaultZero} 

	"This method has no comment."
	
	| retVal {XuArray} |
	(self isBroken) ifTrue:
		[^XuArray makeBrokenBy: self].
	(count isBroken) ifTrue:
		[^XuArray makeBrokenBy: count].
	(start isBroken) ifTrue:
		[^XuArray makeBrokenBy: start].
	(before isBroken) ifTrue:
		[^XuArray makeBrokenBy: before].

	Heaper problems.AllBlasts 
		handle: [:ex | retVal _ XuArray makeBroken: ex asProblem. ex return]
		do: 	[retVal _ XuArray make: (self getActualPrimArray copy:count getActualInt32 with:start getActualInt32 with:before getActualInt32)].
	XuPromise inDelayBlock ifFalse:
		[XuPromise force.
		retVal isBroken ifTrue: [retVal explode]].
	^retVal!

{XuVoid} copyFromBuffer: buffer {void star} 

	^self  copyFromBuffer: buffer with: DefaultZero with: DefaultMinusOne!

{XuVoid} copyFromBuffer: buffer {void star} with: start {XuIntValue default: DefaultZero} 

	^self  copyFromBuffer: buffer with: start with: DefaultMinusOne!

{XuVoid} storeAll

	^self  storeAll: DefaultNull with: DefaultMinusOne with: DefaultZero!

{XuVoid} storeAll: value {XuPromise default: DefaultNull} 

	^self  storeAll: value with: DefaultMinusOne with: DefaultZero!

{XuVoid} storeAll: value {XuPromise default: DefaultNull} with: count {XuIntValue default: DefaultMinusOne} 

	^self  storeAll: value with: count with: DefaultZero! !

!XuArray methodsFor: 'bulk accessing'!

{XuVoid} at: to {XuIntValue} storeMany: source {XuArray} with: count {XuIntValue default: DefaultMinusOne} with: from {XuIntValue default: DefaultZero} 

	"Copy n elements from the source array into this one. The source array must be of a compatible type."
	
	| retVal {XuVoid} |
	(self isBroken) ifTrue:
		[^XuVoid makeBrokenBy: self].
	(to isBroken) ifTrue:
		[^XuVoid makeBrokenBy: to].
	(source isBroken) ifTrue:
		[^XuVoid makeBrokenBy: source].
	(count isBroken) ifTrue:
		[^XuVoid makeBrokenBy: count].
	(from isBroken) ifTrue:
		[^XuVoid makeBrokenBy: from].

	Heaper problems.AllBlasts 
		handle: [:ex | retVal _ XuVoid makeBroken: ex asProblem. ex return]
		do: 	[retVal _ XuVoid make. (self getActualPrimArray at:to getActualInt32 storeMany: ((XuPromise getActual: source) cast: PrimArray) with:count getActualInt32 with:from getActualInt32)].
	XuPromise inDelayBlock ifFalse:
		[XuPromise force.
		retVal isBroken ifTrue: [retVal explode]].
	^retVal!

{XuArray} copy: count {XuIntValue default: DefaultMinusOne} with: start {XuIntValue default: DefaultZero} with: before {XuIntValue default: DefaultZero} with: after {XuIntValue default: DefaultZero} 

	"Make a copy of a piece of this array.  'Count' defaults to the count of the array minus 'start'.  'start' defaults to the beginning of the array, so with arguments, copy just copies the entire array.  'Before' and 'after' both default to 0.  They describe the count of nulls/0s to be added in the result array before the copied elements or after the copied elements.  For example, to copy everything after 10 into a new array leaving room for 20 elements, the incantation would be:
		array->copy(-1,10,20)"
	
	| retVal {XuArray} |
	(self isBroken) ifTrue:
		[^XuArray makeBrokenBy: self].
	(count isBroken) ifTrue:
		[^XuArray makeBrokenBy: count].
	(start isBroken) ifTrue:
		[^XuArray makeBrokenBy: start].
	(before isBroken) ifTrue:
		[^XuArray makeBrokenBy: before].
	(after isBroken) ifTrue:
		[^XuArray makeBrokenBy: after].

	Heaper problems.AllBlasts 
		handle: [:ex | retVal _ XuArray makeBroken: ex asProblem. ex return]
		do: 	[retVal _ XuArray make: (self getActualPrimArray copy:count getActualInt32 with:start getActualInt32 with:before getActualInt32 with:after getActualInt32)].
	XuPromise inDelayBlock ifFalse:
		[XuPromise force.
		retVal isBroken ifTrue: [retVal explode]].
	^retVal!

{XuVoid} copyFromBuffer: buffer {void star} with: start {XuIntValue default: DefaultZero} with: count {XuIntValue default: DefaultMinusOne} 

	"This method has no comment."
	
	| retVal {XuVoid} |
	(self isBroken) ifTrue:
		[^XuVoid makeBrokenBy: self].
	(start isBroken) ifTrue:
		[^XuVoid makeBrokenBy: start].
	(count isBroken) ifTrue:
		[^XuVoid makeBrokenBy: count].

	Heaper problems.AllBlasts 
		handle: [:ex | retVal _ XuVoid makeBroken: ex asProblem. ex return]
		do: 	[retVal _ XuVoid make. (self getActualPrimArray copyFromBuffer: buffer with:start getActualInt32 with:count getActualInt32)].
	XuPromise inDelayBlock ifFalse:
		[XuPromise force.
		retVal isBroken ifTrue: [retVal explode]].
	^retVal!

{XuVoid} storeAll: value {XuPromise default: DefaultNull} with: count {XuIntValue default: DefaultMinusOne} with: start {XuIntValue default: DefaultZero} 

	"Set a range of elements to have the same value"
	
	| retVal {XuVoid} |
	(self isBroken) ifTrue:
		[^XuVoid makeBrokenBy: self].
	(value isBroken) ifTrue:
		[^XuVoid makeBrokenBy: value].
	(count isBroken) ifTrue:
		[^XuVoid makeBrokenBy: count].
	(start isBroken) ifTrue:
		[^XuVoid makeBrokenBy: start].

	Heaper problems.AllBlasts 
		handle: [:ex | retVal _ XuVoid makeBroken: ex asProblem. ex return]
		do: 	[retVal _ XuVoid make. (self getActualPrimArray storeAll: ((XuPromise getActual: value) cast: Heaper) with:count getActualInt32 with:start getActualInt32)].
	XuPromise inDelayBlock ifFalse:
		[XuPromise force.
		retVal isBroken ifTrue: [retVal explode]].
	^retVal! !

!XuArray methodsFor: 'promise access'!

{PrimArray} getActualPrimArray
	self isBroken
		ifFalse: [^super actualThing cast: PrimArray.]
		ifTrue: [Heaper BLAST: #BrokenPromise].! !

!XuArray methodsFor: 'creation'!

create.Problem: problem {Problem}
	super create.Problem: problem.!

create.Promise: promise {XuPromise}
	super create.Promise: promise.!

create: anPrimArray {PrimArray}
	super create: anPrimArray.! !

!XuArray methodsFor: 'accessing'!

{XuVoid} at: index {XuIntValue} storeValue: value {XuPromise} 

	"Store a value in a PrimArray, may be a Heaper, NULL, or a PrimValue.
	It is expected that most PrimArray clients will want to use less abstract
	access methods."
	
	| retVal {XuVoid} |
	(self isBroken) ifTrue:
		[^XuVoid makeBrokenBy: self].
	(index isBroken) ifTrue:
		[^XuVoid makeBrokenBy: index].
	(value isBroken) ifTrue:
		[^XuVoid makeBrokenBy: value].

	Heaper problems.AllBlasts 
		handle: [:ex | retVal _ XuVoid makeBroken: ex asProblem. ex return]
		do: 	[retVal _ XuVoid make. (self getActualPrimArray at:index getActualInt32 storeValue: ((XuPromise getActual: value) cast: Heaper))].
	XuPromise inDelayBlock ifFalse:
		[XuPromise force.
		retVal isBroken ifTrue: [retVal explode]].
	^retVal!

{XuIntValue} count

	"How many elements the array can hold"
	
	| retVal {XuIntValue} |
	(self isBroken) ifTrue:
		[^XuIntValue makeBrokenBy: self].

	Heaper problems.AllBlasts 
		handle: [:ex | retVal _ XuIntValue makeBroken: ex asProblem. ex return]
		do: 	[retVal _ XuIntValue integerVar: (self getActualPrimArray count)].
	XuPromise inDelayBlock ifFalse:
		[XuPromise force.
		retVal isBroken ifTrue: [retVal explode]].
	^retVal!

{XuPromise} getValue: index {XuIntValue} 

	"Fetch a value from a PrimArray, may be a Heaper, NULL, or a PrimValue.
	Clients are expected to perform necessary casting.  It is expected that
	most PrimArray clients will want to use less abstract access methods."
	
	| retVal {XuPromise} |
	(self isBroken) ifTrue:
		[^XuPromise makeBrokenBy: self].
	(index isBroken) ifTrue:
		[^XuPromise makeBrokenBy: index].

	Heaper problems.AllBlasts 
		handle: [:ex | retVal _ XuPromise makeBroken: ex asProblem. ex return]
		do: 	[retVal _ XuPromise make: (self getActualPrimArray getValue:index getActualInt32)].
	XuPromise inDelayBlock ifFalse:
		[XuPromise force.
		retVal isBroken ifTrue: [retVal explode]].
	^retVal!

{PrimArray} spec

	"A description of the kinds of things which can be stored in this array"
	
	| retVal {PrimArray} |
	(self isBroken) ifTrue:
		[^PrimArray makeBrokenBy: self].

	Heaper problems.AllBlasts 
		handle: [:ex | retVal _ PrimArray makeBroken: ex asProblem. ex return]
		do: 	[retVal _ PrimArray make: (self getActualPrimArray spec)].
	XuPromise inDelayBlock ifFalse:
		[XuPromise force.
		retVal isBroken ifTrue: [retVal explode]].
	^retVal!

{XuPromise} valueAt: index {XuIntValue} 

	"Get an individual value from the array. It may be a primitive data type, or a pointer to an object. Blasts if it is NULL."
	
	| retVal {XuPromise} |
	(self isBroken) ifTrue:
		[^XuPromise makeBrokenBy: self].
	(index isBroken) ifTrue:
		[^XuPromise makeBrokenBy: index].

	Heaper problems.AllBlasts 
		handle: [:ex | retVal _ XuPromise makeBroken: ex asProblem. ex return]
		do: 	[retVal _ XuPromise make: (self getActualPrimArray valueAt:index getActualInt32)].
	XuPromise inDelayBlock ifFalse:
		[XuPromise force.
		retVal isBroken ifTrue: [retVal explode]].
	^retVal! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

XuArray class
	instanceVariableNames: ''!

(XuArray getOrMakeCxxClassDescription)
	attributes: ((Set new) add: #CONCRETE; yourself)!

!XuArray class methodsFor: 'pseudo-constructors'!

make: anPrimArray {PrimArray}
	^self create: anPrimArray!

{XuArray} makeBroken: problem {Problem star}
	| broke {XuArray} |
	broke _ self create.Problem: problem.
	XuPromise savePromise: broke.
	^broke!

{XuArray} makeBrokenBy: broken {XuPromise}
	^self create.Promise: broken.! !