'From Objectworks for Smalltalk-80(tm), Version 2.5 of 29 July 1989 on 22 March 1995 at 8:59:48 pm'!

XuPosition subclass: #XuID
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xanadu-Be-Basic'!
XuID comment:
'Implementation note:

An ID exists within a particular IDSpace, and is generated by a particular Server. It holds onto the space and the Server which created it, along with a number identifying the ID uniquely. If mySpace is NULL, then the ID is in the global IDSpace. If myBackend is NULL, then this ID was generated by the current Server (unless myNumber is negative, in which case it is considered to have been generated by the "global" backend). If myBackend is non-NULL, then myNumber must be non-negative.'!

(XuID getOrMakeCxxClassDescription)
	attributes: ((Set new) add: #CONCRETE; yourself)!

!XuID methodsFor: 'promise access'!

{ID} getActualID
	self isBroken
		ifFalse: [^super actualThing cast: ID.]
		ifTrue: [Heaper BLAST: #BrokenPromise].! !

!XuID methodsFor: 'creation'!

create.Problem: problem {Problem}
	super create.Problem: problem.!

create.Promise: promise {XuPromise}
	super create.Promise: promise.!

create: anID {ID}
	super create: anID.! !

!XuID methodsFor: 'accessing'!

{XuIntArray} export

	"Essential. Export this iD in a form which can be handed to Server::importID on any Server to generate the same ID"
	
	| retVal {XuIntArray} |
	(self isBroken) ifTrue:
		[^XuIntArray makeBrokenBy: self].

	Heaper problems.AllBlasts 
		handle: [:ex | retVal _ XuIntArray makeBroken: ex asProblem. ex return]
		do: 	[retVal _ XuIntArray make: (self getActualID export)].
	XuPromise inDelayBlock ifFalse:
		[XuPromise force.
		retVal isBroken ifTrue: [retVal explode]].
	^retVal! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

XuID class
	instanceVariableNames: ''!

(XuID getOrMakeCxxClassDescription)
	attributes: ((Set new) add: #CONCRETE; yourself)!

!XuID class methodsFor: 'pseudo-constructors'!

make: anID {ID}
	^self create: anID!

{XuID} makeBroken: problem {Problem star}
	| broke {XuID} |
	broke _ self create.Problem: problem.
	XuPromise savePromise: broke.
	^broke!

{XuID} makeBrokenBy: broken {XuPromise}
	^self create.Promise: broken.! !