'From Objectworks for Smalltalk-80(tm), Version 2.5 of 29 July 1989 on 22 March 1995 at 9:01:22 pm'!

XuRegion subclass: #XuIDRegion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xanadu-id'!
XuIDRegion comment:
'If mySpace is NULL, then it is assumed to be global IDSpace.
The non-negative part of myLocalIDs contains the number portion of all IDs in the region that were generated by the current backend. The negative part contains all IDs which were generated by the "global" backend.
If myImportedIDs is NULL, it is considered to be empty. If it is non-NULL, it must be non-empty. It contains the numbers of all IDs in this region which were generated by other backends. If an entry in the table could be omitted without effect, then it should be omitted. (i.e. if myIncludesRest and the region is full, or myIncludesRest not and the region is empty, then the entry should be omitted).
If myIncludesRest is true, then the region includes, in addition to those IDs explictly listed in myLocalIDs and myImportedIDs, all ID generated by all other backends.'!

(XuIDRegion getOrMakeCxxClassDescription)
	attributes: ((Set new) add: #CONCRETE; yourself)!

!XuIDRegion methodsFor: 'promise access'!

{IDRegion} getActualIDRegion
	self isBroken
		ifFalse: [^super actualThing cast: IDRegion.]
		ifTrue: [Heaper BLAST: #BrokenPromise].! !

!XuIDRegion methodsFor: 'creation'!

create.Problem: problem {Problem}
	super create.Problem: problem.!

create.Promise: promise {XuPromise}
	super create.Promise: promise.!

create: anIDRegion {IDRegion}
	super create: anIDRegion.! !

!XuIDRegion methodsFor: 'accessing'!

{XuIntArray} export

	"Essential. Export the IDRegion in a form that can be used to recreate it with IDRegion::import."
	
	| retVal {XuIntArray} |
	(self isBroken) ifTrue:
		[^XuIntArray makeBrokenBy: self].

	Heaper problems.AllBlasts 
		handle: [:ex | retVal _ XuIntArray makeBroken: ex asProblem. ex return]
		do: 	[retVal _ XuIntArray make: (self getActualIDRegion export)].
	XuPromise inDelayBlock ifFalse:
		[XuPromise force.
		retVal isBroken ifTrue: [retVal explode]].
	^retVal! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

XuIDRegion class
	instanceVariableNames: ''!

(XuIDRegion getOrMakeCxxClassDescription)
	attributes: ((Set new) add: #CONCRETE; yourself)!

!XuIDRegion class methodsFor: 'pseudo-constructors'!

make: anIDRegion {IDRegion}
	^self create: anIDRegion!

{XuIDRegion} makeBroken: problem {Problem star}
	| broke {XuIDRegion} |
	broke _ self create.Problem: problem.
	XuPromise savePromise: broke.
	^broke!

{XuIDRegion} makeBrokenBy: broken {XuPromise}
	^self create.Promise: broken.! !